#ifndef VERTEX_HH
#define VERTEX_HH

#include "vector.hh"
#include <slist>

class Vertex {
private:
  Vector location_, force, newloc;

  slist<Vertex*> neighbors, corners;
  slist<pair<Vertex*, Vertex*> > curvings;

public:
  Vertex();
  Vertex (const Vector&);

  void addNeighbor (Vertex*);
  void addCorner (Vertex*);
  void addCurving (Vertex*, Vertex*);

  void computeForce();
  void adjust();
  void move();
  void doMove();
  void reset() { force = O; }

  const bool moving() const { return (force.length() >= EPSILON); }

  const Vector& location() const { return location_; }

  friend void translate (const Vector&);
  friend void rotate (const Vector&);

};

#else

#endif
